/*
 * $Id: DataVariableHandler.js,v 1.13 2005/01/10 10:37:53 kps Exp $
 *
 * Copyright (c) 2002 Adventnet, Inc. All Rights Reserved.
 * Please read the associated COPYRIGHTS file for more details.
 *
 * ADVENTNET, INC. MAKES NO REPRESENTATIONS OR WARRANTIES  ABOUT THE SUITABILITY
 * OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, OR
 * NON-INFRINGEMENT. ADVENTNET, INC. SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS
 * SOFTWARE OR ITS DERIVATIVES.
 *
 */

function addDataVariableRow(id, tableAlias, columnValues)
{
	var uniqueId = getUniqueId(id);
    var table = eval(uniqueId + "_" + tableAlias);
    table.push(columnValues);
}

function getDataValueArray(id, tableAlias)
{
   var referenceId = getReferenceId(id);
   var dataVarName = "T" + referenceId + "_" + tableAlias;
   return eval("parent." + dataVarName);
}

function getDataValue(id, tableAlias, index)
{
    var tableArr = getDataValueArray(id,tableAlias);
    if(index == -1)
    {
        return tableArr[0];
    }
    else
    {
        return tableArr[index];
    }
}

function getPKColumnNames(id, tableAlias)
{
	var uniqueId = getUniqueId(id);
	var viewName = stateData[uniqueId]["_VN"];
    return eval(viewName + "_" + tableAlias + "_PKColumnName");
}

function getPKColumnAlias(id, tableAlias)
{
	var uniqueId = getUniqueId(id);
	var viewName = stateData[uniqueId]["_VN"];
        return eval(viewName + "_" + tableAlias + "_PKColumnAlias");
}

function getAllColumnNames(id, tableAlias)
{
	var uniqueId = getUniqueId(id);
	var viewName = stateData[uniqueId]["_VN"];
	return eval(viewName+ "_" + tableAlias + "_ColumnNames");
}

function getRowDataAsObject(id, tableAlias, index)
{
	var uniqueId = getUniqueId(id);
    var allCols = getAllColumnNames(uniqueId,tableAlias);
    var rowDatum = getDataValue(uniqueId, tableAlias, index);

    var innerObj = new Object();
    for (var j=0; j<allCols.length; j++)
    {
		innerObj[allCols[j]] = rowDatum[allCols[j]];
    }
    return innerObj;
}

function getPKValues(id, tableAlias, index)
{
	var uniqueId = getUniqueId(id);
	var pkCols = getPKColumnNames(uniqueId, tableAlias);
	var rowDatum = getDataValue(uniqueId, tableAlias, index);
	var pk = new Object();
	for (var j=0; j<pkCols.length; j++)
	{
		pk[pkCols[j]] = rowDatum[pkCols[j]];
	}
	return pk;
}

function getPKValuesAsString(id, tableAlias, index)
{
	var uniqueId = getUniqueId(id);
	var pk = getPKValues(uniqueId, tableAlias, index)
	var pkValue = "";
	for(var pkName in pk)
	{
		pkValue += "&"+ pkName + "=" + pk[pkName];
	}
	return pkValue;
}
